# ---------------------------------------------------------------------------
# BYE.MPS v3.01 Final: Goodbye Matrix for Mystic BBS v1.07.
# FREEWARE Mystic BBS modification. (C) 1999-2001 Reapern66.
# ---------------------------------------------------------------------------
#   I decided to release the source code, so feel free to make any
#   modifications to this module that you want. I ask in return though
#   if you do modify and distribute it to include the source code.
#
#   You must keep my handle INCLUDED in the credits procedure.
#   I can be reached by email at: reapern66@mindspring.com
# ---------------------------------------------------------------------------

Uses User
GetThisUser

Var
    ANILocation   String,
    StrF          String array (1..17),
    OptF          String array (1..8),

    Index         Byte,
    GetChar       Char,
    Leave          Boolean,

    DropIndex     Byte,
    DropEnd       Boolean,

    Counter       Byte,
    SavedY        Byte,
    Text          String Array (1..5)

#==========================================================================#
Procedure Credit
Begin
   Write('[' + int2str(SavedY) + ';1H[01C')
   WriteLn('|15::|07>>> BYE v3.O: coded by Reapern66 |05[|15wOE!mODDING|05]')
   WriteLn('')
   Writeln('')
   MenuCMD('GH','')
Pend

#--------------------------------------------------------------------------#
Procedure Path_Get

Var MPEpos        Integer

Begin
  ANILocation := ParamStr(0)              
  MPEpos := Length(ANILocation) - Pos('.', ANILocation) - 3
  ANILocation := Copy(ANILocation, 1, MPEpos)
PEnd

#--------------------------------------------------------------------------#
Procedure Exist_Config_File
Begin
  If Not fExist(ANILocation + 'BYE.CFG') then
   #Begin
     WriteLn('')
     Write ('|CR|05FETAL ERROR: |07BYE.CFG File not found')
     Write (' in "' + ANILocation)
     GetChar := Readkey
     Halt
   #End
  EndIf

  If Not fExist(ANILocation + 'BYE.STG') then
   #Begin
     WriteLn('')
     Write ('|CR|05FETAL ERROR: |07BYE.STG File not found')
     Write (' in "' + ANILocation)
     GetChar := Readkey
     Halt
   #End
  EndIf
PEnd

#--------------------------------------------------------------------------#
Procedure Read_Config_File
Begin
 fOpen (1, Text, Reset, ANILocation + 'BYE.CFG')
 for Counter := 1 to 8   fReadLn (1, OptF(Counter)) fend
 fClose (1)

 fOpen (1, Text, Reset, ANILocation + 'BYE.STG')
 for Counter := 1 to 17  fReadLn (1, StrF(Counter)) fend
 fClose (1)
PEnd

#--------------------------------------------------------------------------#
Procedure Display_Header
Begin
  CLS
  dispFile(ANILocation + '\BYE')
  If IsNoFile Then
     WriteLn('')
     Write ('|CR|05BYE ERROR: |07BYE.* File not found')
     Write (' in "' + ANILocation)
     GetChar := Readkey
  EndIf
  SavedY := WhereY + 1
Pend

#--------------------------------------------------------------------------#
Procedure Display_Message
Begin
  Write(OptF(4))
  dispFile(ANILocation + '\BYE.DAT')
  If IsNoFile Then
     WriteLn('')
     Write ('|CR|05BYE ERROR: |07BYE.DAT File not found')
     Write (' in "' + ANILocation)
  EndIf
  SavedY := WhereY + 1
Pend

#--------------------------------------------------------------------------#
Procedure Display_Template
Begin
  Write(OptF(4))
  dispFile(ANILocation + '\BYE.TPL')
  If IsNoFile Then
     WriteLn('')
     Write ('|CR|05BYE ERROR: |07BYE.TPL File not found')
     Write (' in "' + ANILocation)
  EndIf
Pend

#--------------------------------------------------------------------------#
Procedure Write_Message

Var Y   Byte

Begin
  Y := str2int(OptF(5))

  Write(OptF(4) + StrF(13) + UserAlias + StrF(14))
  for Counter := 1 to 5
   #Begin
     Write('[' + int2str(Y) + ';1H' + '[' + OptF(6) + 'C' + OptF(7))
     Text(Counter) := Input(75, 75, 1, '')
     Y := Y + 1
     if Text(Counter) = '' then Counter := 5 endif
   #End
  fend

  for counter := 1 to 5
     Text(counter) := PadRT(Text(counter), 75, ' ')
  fend

  Write('[' + int2str(SavedY) + ';1H')
  If InputYN (OptF(8)) Then
   #Begin
      fOpen    (1, Text, ReWrite, ANILocation + 'BYE.DAT')
      fWriteLn (1, StrF(13) + UserAlias + StrF(14))
      fWriteLn (1, '')
      for Counter := 1 to 5
       fWriteLn (1, StrF(15) + Text(Counter) + StrF(16))
      fend
      fClose(1)
   #End
  EndIf
Pend

#--------------------------------------------------------------------------#
Procedure Bar_OFF
Begin
  Write(StrF(INDEX))
Pend

#--------------------------------------------------------------------------#
Procedure Bar_ON
Begin
  Write(StrF(INDEX + 4))
Pend

#--------------------------------------------------------------------------#
Procedure Drop_YN
Begin
  DropEnd := False
  DropIndex := 1

  Write(StrF(9))
  Stuffkey('H')

  Repeat
    GetChar := ReadKey
    if     GetChar = 'P' or GetChar = 'M' or
           GetChar = 'H' or GetChar = 'K' and DropIndex = 2
      #Begin
        Write(StrF(12))
        DropIndex := 1
      #End
    elseif GetChar = 'H' or GetChar = 'K' or
           GetChar = 'P' or GetChar = 'M' and DropIndex = 1
      #Begin 
        Write(StrF(11))
        DropIndex := 2
      #End
    elseif GetChar = '2' 
      #Begin
        DropIndex := 1
        Write(StrF(12))
      #End
    elseif GetChar = '1' 
      #Begin
        DropIndex := 2
        Write(StrF(11))
      #End
    endif
 
    if Getchar = Chr(13)
      if    DropIndex = 2  then Credit
      elseif DropIndex = 1 then DropEnd := True
      endif
    endif
  until DropEnd
Pend

#--------------------------------------------------------------------------#
Procedure Get_Option
Begin
  if GetChar = 'P' or GetChar = 'M' and Index < 4  
      #Begin
        Bar_OFF
        Index := Index + 1
        Bar_ON
      #End
  elseif GetChar = 'P' or GetChar = 'M' and Index = 4 
      #Begin
        Bar_OFF
        Index := 1
        Bar_ON
      #End
  elseif GetChar = 'H' or GetChar = 'K' and Index > 1  
      #Begin
        Bar_OFF
        Index := Index - 1
        Bar_ON
      #End
  elseif GetChar = 'H' or GetChar = 'K' and Index = 1 
      #Begin
        Bar_OFF
        Index := 4
        Bar_ON
      #End
  elseif GetChar = '1' 
      #Begin
        Bar_OFF
        Index := 1
        Bar_ON
      #End
  elseif GetChar = '2' 
      #Begin
        Bar_OFF
        Index := 2
        Bar_ON
      #End
  elseif GetChar = '3' 
      #Begin
        Bar_OFF
        Index := 3
        Bar_ON
      #End
  elseif GetChar = '4' 
      #Begin
        Bar_OFF
        Index := 4
        Bar_ON
      #End
  endif
Pend

#--------------------------------------------------------------------------#
Procedure Excute_Command
Begin
  if GetChar = Chr(13) then
    if Index = 1
        #Begin
          if Upper (OptF(3)) = 'Y' then Drop_YN  else Credit endif
          Write(StrF(10))
          if OptF(1) = 'R'
           then Bar_ON
           else Write(StrF(13))
          endif
        #End
    elseif Index = 2
      #Begin
        if Upper(Optf(2)) = 'N' then
          #begin
            CLS
            MenuCmd('MW', 'SYSOP')
            Display_Header
            Bar_ON
          #end
        else
          #begin
             Display_Template
             Write_Message
             Display_Header
             Display_Message
             Bar_ON
          #end
        endif
      #End
    elseif Index = 3
        #Begin
          Halt
        #End
    elseif Index = 4
        #Begin
          CLS
          MenuCmd('GP', '')
          Display_Header
          if Upper(Optf(2)) = 'Y' then Write(OptF(4)) Display_Message endif
          Bar_ON
         #End
    endif
  endif
Pend

#--------------------------------------------------------------------------#
Procedure Get_Input
Begin
  Leave := False
  Index := 1
  Bar_On
  Repeat
    GetChar := ReadKey
    Get_Option
    Excute_Command
  until Leave
Pend

###############################
# START of main program block #
###############################
#Begin
  Path_Get
  Exist_Config_File
  Read_Config_File
  Display_Header
  if Upper(OptF(2)) = 'Y' then Display_Message endif
  Get_Input
#End

